#include <windows.h>
#include <stdio.h>

int main( VOID )
{  
   STARTUPINFO si;
   PROCESS_INFORMATION pi;
   DWORD status ;
   HANDLE hEvent;
   
   ZeroMemory( &si, sizeof(si) );
   si.cb = sizeof(si);
   ZeroMemory( &pi, sizeof(pi) );
   
   system("cd"); // juste pour le plaisir
   
   // On crée un événement
   //   - Non signalé par défaut
   //   - A réinitialisation manuelle
   //   - Nommé
   hEvent = CreateEvent( NULL, TRUE, FALSE, "Global\\Event1" );
   
   if( !CreateProcess(".\\Child.exe", NULL, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi)) 
   {   
      printf( "CreateProcess failed (%d).\n", GetLastError() );
      ExitProcess(1);
   }
   
   // Le fils est en attente
   printf("Pret ?\n");
   Sleep(2000);
   printf("Partez !\n");
   
   // C'est parti ! On signale l'évènement au fils
   SetEvent(hEvent);
   
   WaitForSingleObject( pi.hProcess, INFINITE );
   
   if(GetExitCodeProcess( pi.hProcess, &status))
         printf("I am the father. My child [%d,%d] has terminated with (%d). \n", pi.dwProcessId, pi.dwThreadId, status );
   else  printf( "GetExitCodeProcess failed (%d).\n", GetLastError() );

   CloseHandle( pi.hProcess );
   CloseHandle( pi.hThread );
   
   // On détruit l'événement
   CloseHandle(hEvent);
   
   printf( "I am the father. Going to terminate.\n");
   ExitProcess(0);
}

